/***************************************************************
 * Name:      drawing_canvas.h
 * Purpose:   For drawing music
 * Author:    John Conner Atkeson
 * Created:   2007-11-06
 * Copyright: John Conner Atkeson (http://jca3.freeshell.org)
 * License:   LGPL
 **************************************************************/
#ifndef drawing_canvas_h
#define drawing_canvas_h 1
// "No source file named"  "Breakpoint 1"  "pending";
// taskkill /F /IM fretless.exe
#include "wx_pch.h"
#include <wx/msgdlg.h>

//(*InternalHeaders(fretlessDialog)
#include <wx/bitmap.h>
#include <wx/font.h>
#include <wx/fontenum.h>
#include <wx/fontmap.h>
#include <wx/image.h>
#include <wx/intl.h>
#include <wx/settings.h>
#include <wx/string.h>
#include <wx/dcbuffer.h>
#include <wx/dcmemory.h>
//#include "gaudio.h"
#include "audio.h"

#define have_player 1
#define etable 1

class DrawingCanvasClass : public wxPanel {//, public wxTimer
public:
  bool left_mouse_down;
  int counter;
#if have_player
  Player_Class *player;
#endif
  wxPanel* DrawingPanel;
  wxWindow *m_parent;

  class Selector_Class{
  public:
    double time_base_abs, octave_base_abs, loudness_base_abs;
    Playable_Class *selection;
    void Set_Selection(Playable_Class *new_selection){
      selection = new_selection;
      if (selection!=NULL){
        selection->Get_Base_Abs(&(time_base_abs), &(octave_base_abs), &(loudness_base_abs));
      }
    }
  };

  Selector_Class Selector;
  Playable_Tree_Class *Root_Playable;
  Voice_Track_Class *Voice_Track;
  Freewave_Generator_Class *sgen;
  double altstart, loudness_start;
  class Box_Mapper_Class *Box_Map;
  wxBitmap *Background_Pic;
  wxBitmap *Gradient_Backdrop;
  double Trackline_Prev_Time, Trackline_Now_Time;
  class Drawing_Canvas_Timer *Trackline_Timer;
  DrawingCanvasClass::DrawingCanvasClass(wxWindow *parent, int id);
  /* ************************************************************************************************************ */
  DrawingCanvasClass::~DrawingCanvasClass();
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnShow(wxEvent& WXUNUSED(event))
  {
    // wxPaintDC dc(this);
    // Painter(dc);
    // wxMessageBox("Show event handled", _T("Shown"), wxOK | wxICON_INFORMATION, this);
  };
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::Repaint_Background();
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::Fill_Gradient_Backdrop();
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::Painter(wxDC& dc);
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnPaint(wxPaintEvent& event);
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnSize(wxSizeEvent& event);
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnDrawingPanelLeftDown(wxMouseEvent& event);
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnDrawingPanelLeftUp(wxMouseEvent& event);
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnDrawingPanelRightDown(wxMouseEvent& event);
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnDrawingPanelRightUp(wxMouseEvent& event);
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnDrawingPanelMouseMove(wxMouseEvent& event);
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnQuit(wxCommandEvent& event)
  {
    Close();
  };
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::Draw_Trackline();
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnIdle(wxIdleEvent &event);
  /* ************************************************************************************************************ */
  void DrawingCanvasClass::OnTimer(wxTimerEvent& event);
  /* ************************************************************************************************************ */
private:
#ifdef etable
  wxTimer m_timer;
  // DECLARE_CLASS(DrawingCanvasClass)
  DECLARE_EVENT_TABLE()
#endif
};/* DrawingCanvasClass */
/* ************************************************************************************************************ */
class Drawing_Canvas_Timer : public wxTimer{
public:
  DrawingCanvasClass *my_canvas;
  Drawing_Canvas_Timer::Drawing_Canvas_Timer(DrawingCanvasClass *new_canvas);
  overrider void Drawing_Canvas_Timer::Notify();
};
/* ************************************************************************************************************ */
class MyFrame: public wxFrame
{
public:

  MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size);

  void OnQuit(wxCommandEvent& event);
  void OnAbout(wxCommandEvent& event);

  DECLARE_EVENT_TABLE()
};
#endif// drawing_canvas_h

