/***************************************************************
 * Name:      Ersatz.cpp
 * Purpose:   Ersatz is fake Java
 * Author:    John Conner Atkeson
 * Created:   2007-11-06
 * Copyright: John Atkeson (http://jca3.freeshell.org)
 * License:   LPGL
 **************************************************************/

#include "ersatz.h"
// thread wrapper from http://codeguru.earthweb.com/forum/showthread.php?t=430196
void *thread_wrapper(void *pointer){
  Runnable *runner = (Runnable*)pointer;
  runner->Run();
  // pthread_exit( NULL );// throws error: "this application has failed to start because pthreadgce2.dll was not found"
  return NULL;
};
int Runnable::start(){
  int thread_id = pthread_create( &p_thread, NULL, thread_wrapper, (void *)this );
  return thread_id; // the real one does a little more here
};

/* **********************************************************************************************************************
  Box_Mapper_Class functions
********************************************************************************************************************** */
Box_Mapper_Class::Box_Mapper_Class(){
  Set_Screen(0, 0, 1, 1);// default initializations.
  Set_Real(0, 0, 1, 1);
}
//-------------------------------------------------------------------
void Box_Mapper_Class::Set_Screen(double xleft, double ytop, double xright, double ybottom){
  scrleft = xleft; scrright = xright;
  scrtop = ytop; scrbottom = ybottom;
  scrwdt = xright-xleft; scrhgt = ybottom-ytop;
  set_ratios();
}
//-------------------------------------------------------------------
void Box_Mapper_Class::Set_Real(double xleft, double ytop, double xright, double ybottom){
  realleft = xleft; realright = xright;
  realtop = ytop; realbottom = ybottom;
  realwdt = xright-xleft; realhgt = ybottom-ytop;
  set_ratios();
}
//-------------------------------------------------------------------
void Box_Mapper_Class::set_ratios(){
  x_ratio_to_screen = scrwdt/realwdt; y_ratio_to_screen = scrhgt/realhgt;
}
//-------------------------------------------------------------------
double Box_Mapper_Class::Map_X_To_Screen(double xreal){
  return scrleft + ((xreal-realleft) * x_ratio_to_screen);
}
//-------------------------------------------------------------------
double Box_Mapper_Class::Map_Y_To_Screen(double yreal){
  return scrtop + ((yreal-realtop) * y_ratio_to_screen);
}
//-------------------------------------------------------------------
double Box_Mapper_Class::Map_X_To_Real(double xscr){
  return realleft + ((xscr-scrleft) / x_ratio_to_screen);
}
//-------------------------------------------------------------------
double Box_Mapper_Class::Map_Y_To_Real(double yscr){
  return realtop + ((yscr-scrtop) / y_ratio_to_screen);
}
//-------------------------------------------------------------------
void Box_Mapper_Class::Map_To_Screen(double xreal, double yreal, double *xscr, double *yscr){
  (*xscr) = Map_X_To_Screen(xreal); (*yscr) = Map_Y_To_Screen(yreal);
}
//-------------------------------------------------------------------
void Box_Mapper_Class::Map_To_Real(double xscr, double yscr, double *xreal, double *yreal){
  (*xreal) = Map_X_To_Real(xscr); (*yreal) = Map_Y_To_Real(yscr);
}
/* **********************************************************************************************************************
  Box_Mapper_Class methods
********************************************************************************************************************** */

#if 0 // junkyard
class snoo{// http://msdn2.microsoft.com/en-us/library/41w3sh1c.aspx
  public:
  virtual void ds();
};
class ball:public snoo{
  public:
  virtual void ds() OVERRIDE ;
};
struct I1 {
   virtual void f(){};
};

struct X : public I1 {
   virtual void f() override {};
};
#endif
