/***************************************************************
 * Name:      Ersatz.h
 * Purpose:   Ersatz is fake Java, plus some other stuff
 * Author:    John Conner Atkeson
 * Created:   2007-11-06
 * Copyright: John Atkeson (http://jca3.freeshell.org)
 * License: LPGL
 **************************************************************/

#ifndef ersatz_h
#define ersatz_h 1
#include <pthread.h>
/*
  thread wrapper from http://codeguru.earthweb.com/forum/showthread.php?t=430196
  "..\..\..\..\..\Program Files\CodeBlocks\lib\libpthreadGC2.a"
  "..\..\..\..\..\Program Files\CodeBlocks\lib\libpthreadGCE2.a"

  C++ delegates: http://www.codeguru.com/cpp/cpp/cpp_mfc/article.php/c4119/
*/
#define implements :
#define extends :
#define overrider // in the event C++ EVER supports explicit overrides when inheriting from virtual functions

#define int16 short int
#define uint16 unsigned short int
#define int32 int
#define uint32 unsigned int
#define int64 long int
#define uint64 unsigned long int

// #define infinity ((double)1.0e200) // double.MaxValue 1.7976931348623157E+308
#define infinity ((double)100000000000000.0) // double.MaxValue 1.7976931348623157E+308
#define fudge (((double)1.0)/infinity) // 0.00000000000001

/* C++ compatible mem allocation */
#define allocsafe(num_elements,dattype) ((dattype*)calloc(num_elements,sizeof(dattype)) )
#define freesafe(dat) {if (dat!=NULL){free(dat);dat=NULL;} }
#define reallocsafe(ptr,num_elements,dattype) ((dattype*)realloc((ptr),(num_elements)*sizeof(dattype)))

#define array_chunksize 10
#define expand_array_1(array,oldsize,vartype) if (((oldsize) % array_chunksize)==0){array=reallocsafe(array,(oldsize)+array_chunksize,vartype*);}

/* ************************************************************************************************************ */
class Runnable{
  pthread_t p_thread;
public:
  int Runnable::start();
  Runnable::Runnable(){// constructor
  };
  virtual Runnable::~Runnable(){// destructor
  };
  virtual void Runnable::Run(){// thread method
  };
};
/* ************************************************************************************************************ */
static double pi = 3.14159265358979323846264338327950288419716939937510582097494459230781640628620899862803482534211706798214808651328230664709384460955058223172535940812848111745028410270193852110555964462294895493038196;
static double twopi = pi * 2.0;
class Math_Class{
public:
  // static double Pi = 3.14159265358979323846264338327950288419716939937510582097494459230781640628620899862803482534211706798214808651328230664709384460955058223172535940812848111745028410270193852110555964462294895493038196;
  // static double twopi = Pi * 2.0;
  static double Math_Class::Exp(double inval){
    return exp(inval);
  }
  static double Math_Class::Pow(double inval,double power){
    return pow(inval,power);
  }
  static double Math_Class::Log(double inval){
    return log(inval);
  }
  static double Math_Class::Sqrt(double inval){
    return sqrt(inval);
  }
  static double Math_Class::Frand(){// returns a random fraction (0.0 <= fract <= 1.0)
    double randfract = ((double)rand()/(double)RAND_MAX);
    return randfract;
  }
  static double Math_Class::Hypot(double leg0, double leg1){
    return hypotf(leg0, leg1);
  }
  static double Math_Class::Sin(double angle){
    return sin(angle);// sinf?
  }
  static double Math_Class::Cos(double angle){
    return cos(angle);
  }
  static double Math_Class::Floor(double value){
    return floor(value);
  }
  static double Math_Class::Ceil(double value){
    return ceil(value);
  }
  static double Math_Class::Fabs(double inval){
    return fabs(inval);
  }
};// Math;
static Math_Class Math;
/* ************************************************************************************************************* */
class Reffy_Class{// for managing ref counts
public:
  int refcnt;
  Reffy_Class::Reffy_Class(){
    refcnt = 0;
  };
  void Reffy_Class::Ref_To_Me(Reffy_Class **p_to_me){
    (*p_to_me) = this;
    this->refcnt++;
  };
  void Reffy_Class::Unref_Me(Reffy_Class **p_to_me){
    (*p_to_me) = NULL;
    this->refcnt--;
    if (this->refcnt<=0){
      delete this;
    }
  };
};
/* ************************************************************************************************************* */
class Reffy_Ptr_Class{// alternative, for managing ref counts from the parent
public:
  Reffy_Class *child;
  Reffy_Ptr_Class::Reffy_Ptr_Class(){
  };
  void Reffy_Ptr_Class::Point_To(Reffy_Class *new_child){
    if (new_child!=NULL){
      child = new_child; child->refcnt++;
    }
  };
  void Reffy_Ptr_Class::Unref(){
    if (child!=NULL){
      child->refcnt--;
      if (child->refcnt<=0){delete child;}
      child = NULL;
    }
  };
};
/* ************************************************************************************************************* */
template<class list_item> class ArrayList{// just a fill-in class for porting from java
public:
  int count;
  list_item **list;
  ArrayList::ArrayList(){
    count=0;
    list = NULL;
  };
  virtual ArrayList::~ArrayList(){// inefficient, but not heavily used either
    clear();
  };
  virtual void ArrayList::add(list_item *new_member){
    expand_array_1(list, count, list_item);
    list[count]=new_member;
    count++;
  };
  int ArrayList::size(){
    return count;
  };
  list_item *ArrayList::get(int index){
    return list[index];
  };
  void ArrayList::set(int index,list_item *new_member){
    list[index]=new_member;
  };
  void ArrayList::clear(){
    freesafe(list);
    list=NULL;
    count=0;
  };
  void ArrayList::dispose_contents(){
    for (int cnt=0;cnt<count;cnt++){
      delete this->get(cnt);
    }
    this->clear();
  };
  void ArrayList::remove(int takeout){// sucks out one item
    // int item_ptr_size = sizeof(list_item*);
    int tailsize = sizeof(list_item*) * ((count-takeout)-1);// inefficient, but not heavily used either
    if (tailsize>0){ memmove(list+takeout, list+takeout+1, tailsize); }
    count--;
  };
  int ArrayList::get_index(list_item *takeout_member){// finds the index of one item, the hard way
    int num_items = this->size(); int location = 0;
    while (location<num_items){
      list_item *test_member = this->get(location);
      if (takeout_member == test_member){break;}
      location++;
    }
    if (location>=num_items){ location=-1;}
    return location;
  };
  bool ArrayList::remove(list_item *takeout_member){// sucks out one item
    bool success;// "G++" "hashtable.h" http://www.ece.msstate.edu/research/isip/projects/speech/software/documentation/class/dstr/HashTable/index.html
    int founddex = this->get_index(takeout_member);// REALLY inefficient.
    if (founddex>=0){this->remove(founddex); success=true;}
    else{success=false;}
    return success;
  };
};/* ArrayList */
/* ************************************************************************************************************ */
class Box_Mapper_Class{// Box Mapper isn't really java, but it is used througout fretless.
public:
  double realleft, realright, realwdt;
  double realtop, realbottom, realhgt;
  double scrleft, scrright, scrwdt;
  double scrtop, scrbottom, scrhgt;
  double x_ratio_to_screen, y_ratio_to_screen;
  //-------------------------------------------------------------------
  Box_Mapper_Class::Box_Mapper_Class();
  //-------------------------------------------------------------------
  void Set_Screen(double xleft, double xright, double ytop, double ybottom);
  //-------------------------------------------------------------------
  void Set_Real(double xleft, double xright, double ytop, double ybottom);
  //-------------------------------------------------------------------
  void set_ratios();
  //-------------------------------------------------------------------
  double Map_X_To_Screen(double xreal);
  //-------------------------------------------------------------------
  double Map_Y_To_Screen(double yreal);
  //-------------------------------------------------------------------
  double Map_X_To_Real(double xscr);
  //-------------------------------------------------------------------
  double Map_Y_To_Real(double yscr);
  //-------------------------------------------------------------------
  void Map_To_Screen(double xreal, double yreal, double *xscr, double *yscr);
  //-------------------------------------------------------------------
  void Map_To_Real(double xscr, double yscr, double *xreal, double *yreal);
};
/* ************************************************************************************************************ */
// experimenting with delgates
class SomeClass{//http://www.codeproject.com/cpp/FastDelegate.asp
public:
  int test;

  float (SomeClass::*my_memfunc_ptr)(int, char *);
  // For const member functions, it's declared like this:
  float (SomeClass::*my_const_memfunc_ptr)(int, char *) const;

  virtual float some_member_func(int x, char *p) {
    printf("In SomeClass::some_member_func");
    test = 0;
    return 0.0;
  };
  virtual float some_other_member_func(int x, char *p) {
    printf("In SomeClass::some_other_member_func");
    test = 1;
    return 0.0;
  };
  void snox(){
    // my_const_memfunc_ptr = some_member_func;
    my_memfunc_ptr = &SomeClass::some_member_func; // ---- line (*)
    (this->*my_memfunc_ptr)(1, "hello world");

    my_memfunc_ptr = &SomeClass::some_other_member_func; // ---- line (*)
    (this->*my_memfunc_ptr)(1, "hello world");
  };
};


#endif // ersatz_h

#if 0 // junkyard

void *thread_wrapper( void *p );
class thread_class{
  pthread_t p_thread;
public:
  int thread_class::start_thread(){//StartThread
    int thread_id = pthread_create( &p_thread, NULL, thread_wrapper, (void *)this );
    return thread_id; // the real one does a little more here
  };
  thread_class::thread_class(){
  };
  virtual void thread_class::run(){
  };
};
void *thread_wrapper(void *pointer){//InitiateThread
  thread_class *tp = (thread_class*)pointer;
  tp->run();
  // pthread_exit( NULL );// throws error: "this application has failed to start because pthreadgce2.dll was not found"
  return NULL;
};


#endif // junkyard

