/***************************************************************
 * Name:      fretlessMain.h
 * Purpose:   Defines Application Frame
 * Author:    John Conner Atkeson ()
 * Created:   2007-12-02
 * Copyright: John Conner Atkeson (http://jca3.freeshell.org)
 * License:
 **************************************************************/

#ifndef FRETLESSMAIN_H
#define FRETLESSMAIN_H

//(*Headers(fretlessFrame)
#include <wx/sizer.h>
#include <wx/menu.h>
#include <wx/slider.h>
#include <wx/panel.h>
#include <wx/button.h>
#include <wx/frame.h>
#include <wx/statusbr.h>
//*)

class fretlessFrame: public wxFrame
{
    public:

        fretlessFrame(wxWindow* parent,wxWindowID id = -1);
        virtual ~fretlessFrame();

    private:

        //(*Handlers(fretlessFrame)
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnOctave_SliderCmdScrollChanged(wxScrollEvent& event);
        void OnOctave_SliderCmdScroll(wxScrollEvent& event);
        void OnButton1Click(wxCommandEvent& event);
        //*)

        //(*Identifiers(fretlessFrame)
        static const long ID_SLIDER1;
        static const long ID_BUTTON1;
        static const long ID_PANEL1;
        static const long idMenuQuit;
        static const long idMenuAbout;
        static const long ID_STATUSBAR1;
        //*)

        //(*Declarations(fretlessFrame)
        wxButton* Button1;
        wxPanel* Panel1;
        wxStatusBar* StatusBar1;
        wxSlider* Octave_Slider;
        wxBoxSizer* BoxSizer1;
        //*)

        DECLARE_EVENT_TABLE()
};

#endif // FRETLESSMAIN_H
